//
// FT857 housing project
// Part: Tuning knob
// (c) 2018 Jan Uhrin, OM2JU
//
// Using external libraries; original autor comments included
//----------------------------------------------------------------------------------
//
// Rounded primitives for openscad
// (c) 2013 Wouter Robers 

// Syntax example for a rounded block
//translate([-15,0,10]) rcube([20,20,20],2);

// Syntax example for a rounded cylinder
//translate([15,0,10]) rcylinder(r1=15,r2=10,h=20,b=2);

$fn = 32;  // 80

module rcube(Size=[20,20,20],b=2)
{hull(){for(x=[-(Size[0]/2-b),(Size[0]/2-b)]){for(y=[-(Size[1]/2-b),(Size[1]/2-b)]){for(z=[-(Size[2]/2-b),(Size[2]/2-b)]){ translate([x,y,z]) sphere(b);}}}}}


module rcylinder(r1=10,r2=10,h=10,b=2)
{translate([0,0,-h/2]) hull(){rotate_extrude() translate([r1-b,b,0]) circle(r = b); rotate_extrude() translate([r2-b, h-b, 0]) circle(r = b);}}

//------------------------------------------------------------------------------------------

$kh = 16+3.5;  // knob height

color("green")
difference() {
translate([0,0,$kh/2]) rcylinder(r1=39/2,r2=42/2,h=$kh,b=4.0);
translate([0, 0, 3])   linear_extrude(height = 35) circle(36/2);
//translate([0, -70, 5]) linear_extrude(height = 3.8)  square([3.8,80]);
rotate([90,0,0]) translate([0, 6, 14]) linear_extrude(height = 10.0) circle(4.3/2);
translate([0, 0, -5])  linear_extrude(height = 45) circle(5.95/2);
translate([0, 11.9, -3])     sphere(r=5.5);
translate([0, 11.9, -13.1])  sphere(r=14);
}

//translate([0, 0, 0])   linear_extrude(height = 1)  circle(5);


translate([0, 0, 0])   linear_extrude(height = 1.0) circle(10/2);

color("gray")
difference() {
translate([0, 0, 0])   linear_extrude(height = 7.8) circle(14/2);
translate([0, 0, -5])  linear_extrude(height = 45) circle(5.95/2);
//translate([0, -30, 5]) linear_extrude(height = 1.5) square([1.3,30]);
rotate([90,0,0]) translate([0, 5, 2]) linear_extrude(height = 10.0) circle(1.9/2);
//
translate([-30, -1, 3]) linear_extrude(height = 12) square([50,0.5]);        
rotate([0,0,60]) translate([-30, -1, 3]) linear_extrude(height = 12) square([50,0.5]);        
rotate([0,0,128]) translate([-30, -1, 3]) linear_extrude(height = 12) square([50,0.5]);        
}



color("yellow") {
rotate([0,0,0])     translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,0+72])  translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,0+102])  translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,0+180]) translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,0+255]) translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,0+285]) translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,45+0])  translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,45+90])  translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,45+180])  translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
rotate([0,0,45+270])  translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);

    
//rotate([0,0,43]) translate([7, 0, 1.99])     linear_extrude(height = 6) square([10.9,1]);
//rotate([0,0,90+48]) translate([7, 0, 1.99])  linear_extrude(height = 6) square([10.9,1]);
//rotate([0,0,180+30]) translate([7, 0, 1.99]) linear_extrude(height = 6) square([10.9,1]);
//rotate([0,0,270+50]) translate([7, 0, 1.99]) linear_extrude(height = 6) square([10.9,1]);
}